/**
 * @package koa-files
 * @license MIT
 * @version 2.3.8
 * @author nuintun <nuintun@qq.com>
 * @description A static files serving middleware for koa.
 * @see https://github.com/nuintun/koa-files#readme
 */

'use strict';

const Files = require('./Files.cjs');

/**
 * @module index
 * @license MIT
 * @author nuintun
 */
/**
 * @function server
 * @param {string} root
 * @param {Options} options
 */
function server(root, options) {
  const files = new Files(root, options);
  if (options && options.defer) {
    return async (context, next) => {
      await next();
      await files.response(context);
    };
  }
  return async (context, next) => {
    if (!(await files.response(context))) {
      await next();
    }
  };
}

module.exports = server;
